#include <CL/sycl.hpp>
#include <iostream>
using namespace sycl;

int main() {

  // Loop through the available platforms
  for (auto const& this_platform : platform::get_platforms() ) {
    std::cout << "Plataforma: " << this_platform.get_info<info::platform::name>()    << "\n";
    std::cout << "            " << this_platform.get_info<info::platform::vendor>()  << "\n";
    std::cout << "            " << this_platform.get_info<info::platform::version>() << "\n";

    // Loop through the devices available in this plaform
    for (auto const& this_device : this_platform.get_devices() ) {
      std::cout << "Dispositivo: "  << this_device.get_info<info::device::name>()   << "\n";
      std::cout << "             "  << this_device.get_info<info::device::vendor>() << "\n";
      std::cout << "             host(): "        << (this_device.is_host()        ? "Yes" : "No") << "\n";
      std::cout << "             cpu(): "         << (this_device.is_cpu()         ? "Yes" : "No") << "\n";
      std::cout << "             gpu(): "         << (this_device.is_gpu()         ? "Yes" : "No") << "\n";
      std::cout << "             accelerator(): " << (this_device.is_accelerator() ? "Yes" : "No") << "\n";
    }
    std::cout << "\n";
  }
  return 0;
}

