#include <CL/sycl.hpp>
#include <iostream>
#include <math.h>
using namespace sycl;

constexpr int N = 42;

int main() {

  queue Q{host_selector{}};

  std::cout << "Dispositivo: " << Q.get_device().get_info<info::device::name>()   << "\n";
  std::cout << "             " << Q.get_device().get_info<info::device::vendor>() << "\n";

  auto* shared_array = malloc_shared<float>(N, Q);

  for (int i = 0; i < N; i++)
    shared_array[i] = i;

  Q.submit([&](handler& h) {
    h.parallel_for(N, [=](id<1> i) {
      // access sharedArray on device
      shared_array[i] = sqrt(shared_array[i]);
    });
  });
  Q.wait();

  for(int i = 0; i < N; ++i) 
    std::cout << '[' << shared_array[i] << ']'; std::cout << std::endl;

  free(shared_array, Q);
  return 0;
}
